#!/usr/bin/env python

import gobject

import dbus
import dbus.service
import dbus.mainloop.glib

class OpenPGPAppletObject(dbus.service.Object):
    def __init__(self, conn, object_path='/org/Tails/OpenPGPApplet'):
        dbus.service.Object.__init__(self, conn, object_path)

    @dbus.service.signal('org.Tails.OpenPGPApplet',
                         signature='b')
    def ClipboardContentChanged(self, is_encrypted):
        print("ClipboardContentChanged: {is_encrypted}".format(is_encrypted=is_encrypted))

    @dbus.service.method('org.Tails.OpenPGPApplet')
    def EmitTrue(self):
        self.ClipboardContentChanged(True)

    @dbus.service.method('org.Tails.OpenPGPApplet')
    def EmitFalse(self):
        self.ClipboardContentChanged(False)

    @dbus.service.method('org.Tails.OpenPGPApplet')
    def SymmetricEncryptClipboard(self):
        print("SymmetricEncryptClipboard")

    @dbus.service.method('org.Tails.OpenPGPApplet')
    def AsymmetricEncryptSignClipboard(self):
        print("AsymmetricEncryptSignClipboard")

    @dbus.service.method('org.Tails.OpenPGPApplet')
    def DecryptVerifyClipboard(self):
        print("DecryptVerifyClipboard")

if __name__ == '__main__':
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)

    session_bus = dbus.SessionBus()
    name = dbus.service.BusName('org.Tails.OpenPGPApplet', session_bus)
    object = OpenPGPAppletObject(session_bus)

    loop = gobject.MainLoop()
    loop.run()
